% CRUNCH.M does one time crunching out of search, impresp, 
% and vardecmp.  It is called by DRAWS.M

RE_SEARCH = 2; % How often should search be started from a new random vector at each iteration.
DO_CHOLESKY = 0; % = 1: does Cholesky with aa corresp. to the last variable
DO_SOLVE = 1;
DO_AARAND = 0;
DO_REJECT = 1;
DO_SAMPLE = 1;
N_SAMPLE = 100;

CRUNCH_HORIZON = HORIZON;


if DO_CHOLESKY,
   AAA = chol(sig);
   AAA = AAA';
   aa = AAA(:,POL_SHOCK);
   if aa(POL_SHOCK)*POL_SIGN < 0,
      aa = - aa;
   end;
   aa_opt = aa;
   alpha_opt = zeros(nvar-1,1);
elseif DO_SOLVE,  % MAKE SURE THAT FFR IS ORDERED LAST!!!
      [eigvec,eigval] = eig(sig);
      eigsqrt = sqrt(diag(eigval));
      sig_sqrt = eigvec * diag(eigsqrt);
      if DO_AARAND,
         aa_rand = - rand(nvar,1); % negative response of all variables ...
      else
         aa_rand = - ones(nvar,1);
      end;
      aa_rand(nvar) = - aa_rand(nvar); % ... , except: positive response of FFR.
      sphere = sig_sqrt \ aa_rand;
      sphere = sphere/sqrt(sphere'*sphere);
      aa = sig_sqrt * sphere;
      aa_opt = aa;
      alpha_opt = zeros(nvar-1,1);
elseif DO_REJECT,  % MAKE SURE THAT FFR IS ORDERED LAST!!!
   if DO_SAMPLE,
      [eigvec,eigval] = eig(sig);
      eigsqrt = sqrt(diag(eigval));
      j_sample = 0;
      aa_opt = zeros(nvar,1);
      cri_opt = 1000000000;
      while j_sample < N_sample,
         sphere = randn(nvar,1);
         sphere = sphere/sqrt(sphere'*sphere);
         aa = sum( diag( sphere.*eigsqrt ) * eigvec' );
         aa = aa';
         % impresp;
         aa_test = max(aa,0);
         aa_test(nvar) = max(- aa(nvar),0);
         cri = sum(aa_test.^2);
         if cri < 0.00001,
            aa_opt = aa;
            j_sample = N_sample;
            cri_opt = cri;
         elseif cri < cri_opt,
            cri_opt = cri;
            aa_opt = aa;
         end;
         j_sample = j_sample + 1;
      end;
      alpha_opt = zeros(nvar-1,1);
   else
      disp('***   CRUNCH.M: WARNING: THIS STILL NEEDS TO BE CODED!!! NO ACTION TAKEN.  EXPECT CRASH ***');
   end;
else
   al_vec = [];
   cr_vec = [];
   aa_vec = [];
   for n_search = 1 : RE_SEARCH,
      disp(sprintf('CRUNCH: search # %5.0f out of %5.0f',n_search,RE_SEARCH));
      HORIZON = HOW_FAR; % To economize on calculations;
      search;
      al_vec = [ al_vec, alpha_opt ];
      cr_vec = [ cr_vec, critval ]; 
      aa_vec = [ aa_vec, aa_opt ];
   end;
   [critval,indx] = min(cr_vec);
   alpha = al_vec(:,indx);
   alpha_opt = alpha;
   aa = aa_vec(:,indx);
   aa_opt = aa;
end;
HORIZON = CRUNCH_HORIZON; % To get the full impulse response
vardecmp;
impresp;  % Needs to be used last to keep the impulse response for aa!!!
