% Search for impulse vectors
global eigvec eigsqrt scale_fct sphere
global HOW_FAR WEIGHTS SIDE SCALE ALPHSUM

SEARCH_MODE = 2; % = 0: start from previous optimum
                 % = 1 for entirely new search;
                 % = 2 for random start
DO_ON_SPHERE = 1; % use spherical coordinates, i.e. start with alpha of length nvar - 1
          % YOU NEED TO SET THE SAME OPTION ALSO IN CRIT.M!!!
N_REDO = 2;

scale_fct = ones(nvar,1);
[eigvec,eigval] = eig(sig);
eigsqrt = sqrt(diag(eigval));
if SEARCH_MODE == 0,
   alpha_start = alpha_opt;
elseif SEARCH_MODE == 1,
   if DO_ON_SPHERE,
      alpha_start = ones(nvar-1,1);
   else
      alpha_start = ones(nvar,1)/sqrt(nvar);
   end;
else
   if DO_ON_SPHERE,
      alpha_start = randn(nvar-1,1);
   else
     alpha_start = randn(nvar,1);
     alpha_start = alpha_start/sqrt(alpha_start'*alpha_start);
   end;
end;
% alpha_opt = fmins('crit',alpha_start,[1,1.e-8,1.e-8,0, 0,0,0,0,0, 0,0,0, 400]);
% alpha_opt = fmins('crit',alpha_start,1);
alpha_opt = fmins('crit',alpha_start);
critval = crit(alpha_opt);
disp(sprintf('Round  1: crit = %10.5f',critval));
for redo_count = 1 : N_REDO,
   % alpha_opt = fmins('crit',alpha_opt,1);
   alpha_opt = fmins('crit',alpha_opt);
   critval = crit(alpha_opt);
   disp(sprintf('Round %2.0f: crit = %10.5f',redo_count+1,critval));
end;
aa_opt = aa;
scale_fct = scale_old;
disp('SEARCH: DONE');
